# SmartTV-MQTT2SERIAL
[![MIT license](https://img.shields.io/badge/License-MIT-blue.svg)](LICENSE)

This repository contains scripts and configurations to facilitate the remote control and integration of a Smart TV into various systems. With these files, you can control the power state, volume, mute status, input sources, and other functionalities of your Smart TV via Home Assistant or Node-RED.

# Files Overview

`script.sh`
The script.sh Bash script is designed to be used within Home Assistant or with Node-RED to control the Smart TV remotely via SSH. It includes functions to send commands, reboot the OPS, and change the audio source.

`smarttv.py`
The smarttv.py Python script is intended to be executed on the Smart TV itself. It facilitates serial communication with the Smart TV, enabling control over various aspects such as power state, volume level, mute status, and input source.

## Usage

### Bash Script (`script.sh`)

To use the Bash script within Home Assistant or Node-RED:

1. Modify the script to set up SSH connection details, ensuring compatibility with your Home Assistant or Node-RED environment.
2. Execute the script with appropriate commands to send to the Smart TV OPS.

### Python Script (`smarttv.py`)

To utilize the Python script on the Smart TV:

1. Copy the smarttv.py script to the Smart TV device.
2. Ensure proper setup and permissions to execute the script on the Smart TV.
3. Execute the script with command-line arguments to control the Smart TV functionalities.

## Integration

### Home Assistant

For integration into Home Assistant, the script.sh Bash script can be invoked within Home Assistant using the command_line platform. This enables seamless control of the Smart TV alongside other devices and entities in your Home Assistant setup.

### Node-RED

Similarly, the script.sh script can be integrated into Node-RED workflows using the exec node. This allows for visual automation and control flows, enabling flexible and powerful Smart TV control within the Node-RED environment.

## Requirements

- For `script.sh`: Bash shell environment, sshpass package, proper SSH access to the Smart TV OPS.
- For `smarttv.py`: Python 3, serial port access, compatible Smart TV with serial control capability.

## Future Updates

- [ ] MQTT integration from host to HA
- [ ] Docker container

## Disclaimer

Use these scripts and configurations responsibly and ensure appropriate authorization for remote control and integration of your Smart TV. Ensure compatibility and proper setup before executing any commands or configurations.

## License

The scripts and configurations are provided under the MIT License. See the [LICENSE](LICENSE) file for details.

Feel free to explore, modify, and enhance these files according to your specific requirements and preferences. If you encounter any issues or have further questions, don't hesitate to reach out for assistance.

## 🤝 Support

Contributions, issues, and feature requests are welcome!

Give a ⭐️ if you like this project!